local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST
-- TODO
-- change  L.npc_SiegeOfOrgrimmar["adds"],
do
	local data = {
		version = 1,
		key = "Iron Juggernaut",
		zone = L.zone["Siege of Orgrimmar"],
		category = L.zone["Siege of Orgrimmar"],
		name = L.npc_SiegeOfOrgrimmar["Iron Juggernaut"],
		icon = "INTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-IRON JUGGERNAUT.BLP:35:35",
		triggers = {
			scan = {71466}, 
		},
		onactivate = {
			tracing = {71466},
			tracerstart = true,
			combatstop = true,
			defeat = {71466},
			unittracing = {"boss1"},
		},
		enrage = {
			time10n = 480,
			time25n = 480,
			time10h = 480,
			time25h = 480,
			timeflex = 480,
		},
		--[[arrows = {
			MortalBarragearrow = {
				varname = SN[144553],
				unit = "&upvalue&",
				persist = 5,
				action = "AWAY",
				msg = L.alert["MOVE AWAY!"],
				spell = SN[144553],
				range1 = 9,
				range2 = 11,
				range3 = 12,
				ability = 8132,
				icon = ST[144553],
			},
		},--]]
		windows = {
			proxwindow = true,
			proxrange = 8,
		},
		userdata = {
			phase = 1,
			Add = "",
		},
		raidicons = {
			AddMark = {
				varname = L.npc_SiegeOfOrgrimmar["adds"],
				type = "MULTIENEMY",
				persist = 20,
				unit = "<Add>",
			--	id = 72050,
				reset = 3,
				icon = 1,
				total = 5,
			},
		},
		onstart = {
			{
				"alert",{"SiegeModecd", time = 2},
				"alert",{"IgniteArmorcd", time = 2},
				"batchalert",{"LaserBurncd","BorerDrillcd","CrawlerMinecd"},
			},
		},
		announces = { 
			--[[MortalBarragesay = {
				varname = format(L.alert["%s %s %s!"],SN[144553],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[144553],L.alert["on"],L.alert["Me"]),
				ability = 8132,
				icon = ST[144553],
			},--]]
			CutterLasersay = {
				varname = format(L.alert["%s %s %s!"],SN[146325],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[146325],L.alert["on"],L.alert["Me"]),
				ability = 8132,
				icon = ST[146325],
			},				
		},
		messages = {
			--[[mMortalBarrage = {
				varname = format(L.alert["%s %s %s"],SN[144553],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &upvalue&"],SN[144553],L.alert["on"]),
				color1 = "INDIGO",
				sound = "ALERT13",
				ability = 8132,
				icon = ST[144553],
			},--]]
			mSeismic = {
				varname = format(L.alert["%s!"],SN[144483]),
				type = "message",
				text = format(L.alert["%s!"],SN[144483]),
				color1 = "PEACH",
				sound = "ALERT13",
				ability = 8130,
				icon = ST[144483],
			},
			mLaserStrike = {
				varname = format(L.alert["%s!"],SN[144456]),
				type = "message",
				text = format(L.alert["%s!"],SN[144456]),
				color1 = "ORANGE",
				sound = "ALERT13",
				ability = 8130,
				icon = ST[144456],
			},
			mCrawlerMine = {
				varname = format(L.alert["%s!"],SN[146342]),
				type = "message",
				text = format(L.alert["%s!"],SN[146342]),
				color1 = "RED",
				sound = "ALERT13",
				ability = 8130,
				icon = ST[146342],
			},
			mDemolisherCanons = {
				varname = format(L.alert["%s!"],SN[144154]),
				type = "message",
				text = format(L.alert["%s!"],SN[144154]),
				color1 = "GOLD",
				sound = "ALERT13",
				ability = 8130,
				icon = ST[144154],
			},
			mIgniteArmor = {
				varname = format(L.alert["%s %s %s (1)"],SN[144467],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5# (1)"],SN[144467],L.alert["on"]),
				text2 = format(L.alert["%s %s #5# (#11#)"],SN[144467],L.alert["on"]),
				color1 = "ORANGE",
				sound = "ALERT13",
				ability = 8130,
				icon = ST[144467],
			},
			mCutterLaser = {
				varname = format(L.alert["%s %s %s"],SN[146325],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s #5#"],SN[146325],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				ability = 8130,
				icon = ST[146325],
			},	
			mBorerDrill = {
				varname = format(L.alert["%s"],SN[144209]),
				type = "message",
				text = format(L.alert["%s"],SN[144209]),
				color1 = "ORANGE",
				sound = "ALERT13",
				ability = 8130,
				icon = ST[144209],
			},			
			mNapalmOil = {
				varname = format(L.alert["%s"],SN[144492]),
				type = "message",
				text = format(L.alert["%s"],SN[144492]),
				color1 = "ORANGE",
				sound = "ALERT13",
				ability = 8130,
				icon = ST[144492],
			},	
		},
		alerts = {
			-- Cooldowns
			AssaultModecd = {
				varname = format(L.alert["%s Cooldown"],SN[141395]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[141395]),
				time = 64,
				color1 = "NEWBLUE",
				icon = ST[141395],
				ability = 8132,
			},
			IgniteArmorcd = {
				varname = format(L.alert["%s Cooldown"],SN[144467]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[144467]),
				time = 10,
				time2 = 9,
				color1 = "NEWBLUE",
				icon = ST[144467],
				ability = 8132,
				exhealer = true,
				exdps = true,
			},
			LaserBurncd = {
				varname = format(L.alert["%s Cooldown"],SN[144459]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[144459]),
				time = 12,
				color1 = "NEWBLUE",
				icon = ST[144459],
				ability = 8132,
				extank = true,
				exdps = true,
			},
			BorerDrillcd = {
				varname = format(L.alert["%s Cooldown"],SN[144218]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[144218]),
				time = 19,
				color1 = "NEWBLUE",
				icon = ST[144218],
				ability = 8132,
			},
			CrawlerMinecd = {
				varname = format(L.alert["%s Cooldown"],SN[144673]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[144673]),
				time = 30,
				time2 = 25,
				time3 = 18,
				color1 = "NEWBLUE",
				icon = ST[144673],
				ability = 8132,
			},
			------------------
			SiegeModecd = {
				varname = format(L.alert["%s Cooldown"],SN[84974]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[84974]),
				time = 116,
				time2 = 120.5,
				color1 = "NEWBLUE",
				icon = ST[84974],
				ability = 8132,
			},
			DemolisherCanoncd = {
				varname = format(L.alert["%s Cooldown"],SN[144154]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[144154]),
				time = 10,
				color1 = "NEWBLUE",
				icon = ST[144154],
				ability = 8132,
			},
			MortarBarragecd = {
				varname = format(L.alert["%s Cooldown"],SN[144554]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[144554]),
				time = 30,
				color1 = "NEWBLUE",
				icon = ST[144554],
				ability = 8132,
			},
			NapalmOilcd = {
				varname = format(L.alert["%s Cooldown"],SN[144492]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[144492]),
				time = 20,
				time2 = 10,
				color1 = "NEWBLUE",
				icon = ST[144492],
				ability = 8132,
			},
			Phase1cd = {
				varname = format(L.alert["%s Cooldown"],SN[146359]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[146359]),
				time = 64,
				color1 = "NEWBLUE",
				icon = ST[146359],
				ability = 8132,
			},
			Phase2cd = {
				varname = format(L.alert["%s Cooldown"],SN[146360]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[146360]),
				time = 120,
				color1 = "NEWBLUE",
				icon = ST[146360],
				ability = 8132,
			},					
			-- Alert
			--[[wBorerDrill = {
				varname = format(L.alert["%s %s!"],SN[144209],L.alert["Incoming"]),
				type = "simple",
				text = format(L.alert["%s %s!"],SN[144209],L.alert["Incoming"]),
				time = 2,
				color1 = "RED",
				icon = ST[144209],
				sound = "ALERT11",
				ability = 8132,
			},--]]
			wShockPulse = {
				varname = format(L.alert["%s %s!"],SN[144485],L.alert["Incoming"]),
				type = "simple",
				text = format(L.alert["%s %s!"],SN[144485],L.alert["Incoming"]),
				time = 2,
				color1 = "RED",
				icon = ST[144485],
				sound = "ALERT11",
				ability = 8132,
			},
			wMortarBarrage = {
				varname = "(H) "..format(L.alert["%s!"],SN[144554]),
				type = "simple",
				text = format(L.alert["%s!"],SN[144554]),
				time = 2,
				color1 = "RED",
				icon = ST[144554],
				sound = "ALERT10",
				ability = 8132,
			},			
			wMortarCannon = {
				varname = format(L.alert["%s!"],SN[144316]),
				type = "simple",
				text = format(L.alert["%s!"],SN[144316]),
				time = 2,
				color1 = "RED",
				icon = ST[144316],
				sound = "ALERT11",
				ability = 8132,
			},
			wPhase1 = {
				varname = format(L.alert["Phase 1"]),
				type = "simple",
				text = format(L.alert["Phase 1"]),
				time = 2,
				color1 = "RED",
				icon = ST[146359],
				sound = "ALERT13",
			},
			wPhase2 = {
				varname = format(L.alert["Phase 2"]),
				type = "simple",
				text = format(L.alert["Phase 2"]),
				time = 2,
				color1 = "RED",
				icon = ST[146360],
				sound = "ALERT13",
			},				
			-- Inform
			iMortalBarrageself = {
				varname = format(L.alert["%s %s %s!"],SN[144553],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[144553],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				icon = ST[144553],
				sound = "ALERT10",
				ability = 8132,
				flashscreen = true,
			},
			-- Cast
			CutterLaserCast = {
				varname = format(L.alert["%s: %s"],L.alert["player"],format(L.alert["%s Active"],SN[146325])),
				type = "centerpopup",
				text = format(L.alert["%s: %s"],L.alert["YOU"],format(L.alert["%s Active"],SN[146325])),
				text2 = format(L.alert["#5#: %s"],format(L.alert["%s Active"],SN[146325])),
				time = 15,
				color1 = "RED",
				ability = 8130,
				icon = ST[146325],
				tag = "#5#",
			},
			ShockPulseCast = {
				varname = format(L.alert["%s Active"],SN[144485]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[144485]),
				time = 4,
				color1 = "RED",
				ability = 8130,
				icon = ST[144485],
				tag = "#5#",
			},				
			-- Debuff
			IgniteArmorDebuff = {
				varname = format(L.alert["%s Debuff"],SN[144467]),
				type = "debuff",
				text = format(L.alert["%s (1): %s"],L.alert["YOU"],SN[144467]),
				text2 = format(L.alert["#5# (1): %s"],SN[144467]),
				text3 = format(L.alert["%s (#11#): %s"],L.alert["YOU"],SN[144467]),
				text4 = format(L.alert["#5# (#11#): %s"],SN[144467]),
				time = 30,
				color1 = "ORANGE",
				ability = 8130,
				icon = ST[143494],
				tag = "#5#",
				exdps = true,
			},
			CuttingLaserDebuff = {
				varname = format(L.alert["%s Debuff"],SN[146325]),
				type = "debuff",
				text = format(L.alert["%s (1): %s"],L.alert["YOU"],SN[146325]),
				text2 = format(L.alert["#5# (1): %s"],SN[146325]),
				text3 = format(L.alert["%s (#11#): %s"],L.alert["YOU"],SN[146325]),
				text4 = format(L.alert["#5# (#11#): %s"],SN[146325]),
				time = 10,
				color1 = "ORANGE",
				ability = 8130,
				icon = ST[146325],
				tag = "#5#",
				exdps = true,
			},
		},
		events = {
			--MortalBarrage
			--[[{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {144553},
				execute = {
					--{
						--"alert","wFoulStream",
						--"openwindow",{"8"},
					--},
					{
						"target",{
							source = "#1#",
							wait = 0.25,
							schedule = 16,
							--raidicon = "FoulStreammark",
							arrow = "MortalBarragearrow",
							arrowrange = 9,
							announce = "MortalBarragesay",
							message = "mMortalBarrage",
							alerts = {
								self = "iMortalBarrageself",
								--other = 
								--unknown = "",
							},
						},
					},
				},
			},--]]
			-- Detonation Sequence
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {144718},
				execute = {
					{
						"set",{Add = "#5#"},
						"raidicon","AddMark",
					},
				},
			},
			{
				type = "event",
				event = "UPDATE_MOUSEOVER_UNIT",
				execute = {
					{
						"expect",{"&bossid|mouseover&","==","72050"}, -- Crawler Mine
						"set",{Add = "&bossid|mouseover|true&"},
						"raidicon","AddMark",
						--"debug",{"<AddMark> AddMark"},
					},
				},
			},
			-- CutterLaser
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {146325},
				execute = {
					{
						"message","mCutterLaser",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","CutterLaserCast",
						"announce","CutterLasersay",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert",{"CutterLaserCast", text = 2},
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {146325},
				execute = {
					{
						"quash","CutterLaserCast",
					},
				},
			},
			-- IgniteArmor
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {144467},
				execute = {
				--	{
						--"expect",{"&unitisplayer|#5#&","==","true"},
						--"invoke",{
							{
								"message","mIgniteArmor",
							},
							{
								"expect",{"#4#","==","&playerguid&"},
								"alert","IgniteArmorDebuff",
							},
							{
								"expect",{"#4#","~=","&playerguid&"},
								"alert",{"IgniteArmorDebuff", text = 2},
							},
					--	},
				--	},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellid = {144467},
				execute = {
					--{
						--"expect",{"&unitisplayer|#5#&","==","true"},
						--"invoke",{
							{
								"message",{"mIgniteArmor", text = 2},
							},						
							{
								"expect",{"#4#","==","&playerguid&"},
								"alert",{"IgniteArmorDebuff", text = 3},
							},
							{
								"expect",{"#4#","~=","&playerguid&"},
								"alert",{"IgniteArmorDebuff", text = 4},
							},
					--	},
					--},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {144467},
				execute = {
					{
						"quash","IgniteArmorDebuff",
					},
				},
			},
			--BorerDrill
			--[[{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {144209},
				execute = {
					{
						"alert","wBorerDrill",
					},
				},
			},	--]]
			--Seismic Activity
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {144483},
				execute = {
					{
						"message","mSeismic",
						"closewindow",
					},
					{
						"expect",{"&heroic&","==","true"},
						"alert","MortarBarragecd",
					},
				},
			},
			--ShockPulse
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {144485},
				execute = {
					{
						"batchalert",{"wShockPulse","ShockPulseCast"},
					},
				},
			},
			--LaserStrike
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {144456},
				execute = {
					{
						"message","mLaserStrike",
					},
				},
			},
			--CrawlerMine
			--[[{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {146342},
				execute = {
					{
						"message","mCrawlerMine",
					},
				},
			},--]]
			--DemolisherCanons
			--[[{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellid = {144154},
				execute = {
					{
						"message","mDemolisherCanons",
					},
				},
			},--]]
			-----
			{
                type = "event",
                event = "UNIT_SPELLCAST_SUCCEEDED",
                execute = {
					{
						"expect",{"#1#","==","boss1"},
						"invoke",{
							{
								"expect",{"#5#","==","145407"}, -- MortarCannon
								"expect",{"&isranged&","==","true"},
								"alert","wMortarCannon",
							},
							{
								"expect",{"#5#","==","144198"}, -- DemolisherCanon
								"message","mDemolisherCanons",
							},							
							{
								"expect",{"#5#","==","144296"}, -- BorerDrill
								"alert","BorerDrillcd",
								"message","mBorerDrill",
							},
							{
								"expect",{"#5#","==","144673"}, -- Crawler Mine
								"message","mCrawlerMine",
								"invoke",{
									{
										"expect",{"<phase>","==","1"},
										"alert","CrawlerMinecd",
									},	
									{
										"expect",{"<phase>","~=","1"},
										"alert",{"CrawlerMinecd", time = 2},
									},								
								},
							},
							{
								"expect",{"#5#","==","144492"}, -- Napalm Oil
								"alert","NapalmOilcd",
								"message","mNapalmOil",
							},
							{
								"expect",{"#5#","==","146359"}, -- Regeneration
								"set",{phase = 1},
								"batchalert",{"wPhase1","LaserBurncd","CrawlerMinecd","BorerDrillcd","Phase2cd"},
								"batchquash",{"NapalmOilcd","Phase1cd"},
								"openwindow",{"8"},
							},
							{
								"expect",{"#5#","==","146360"}, -- Siege mode
								"set",{phase = 2},
								"batchalert",{"wPhase2","Phase1cd"},
								"alert",{"CrawlerMinecd", time = 3},
								"alert",{"NapalmOilcd", time = 2},
								"batchquash",{"LaserBurncd","Phase2cd","BorerDrillcd","IgniteArmorcd"},
							},	
							{
								"expect",{"#5#","==","144555"}, -- MortarBarrage
								"batchalert",{"MortarBarragecd","wMortarBarrage"},
							},							
						},
					},
				},
			},			
		},
	}

	DXE:RegisterEncounter(data)
end
